diff --git a/targetcli/ui_root.py b/targetcli/ui_root.py
index deda9f0..a55c20d 100644
--- a/targetcli/ui_root.py
+++ b/targetcli/ui_root.py
@@ -2,7 +2,7 @@
 Implements the targetcli root UI.
 
 This file is part of targetcli.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -16,13 +16,13 @@ WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 License for the specific language governing permissions and limitations
 under the License.
 '''
-
 from os import system
-from rtslib import RTSRoot
-from ui_node import UINode
+import readline, tempfile
+from rtslib import RTSRoot, Config
+from ui_node import UINode, STARTUP_CONFIG
 from socket import gethostname
+from cli_config import CliConfig
 from ui_target import UIFabricModule
-from tcm_dump import tcm_full_backup
 from ui_backstore import UIBackstores
 from ui_backstore_legacy import UIBackstoresLegacy
 
@@ -89,10 +89,45 @@ class UIRoot(UINode):
             input = None
             self.shell.con.display('')
         if input == "yes":
-            tcm_full_backup(None, None, '1', None)
+            config = Config()
+            config.load_live()
+            with open(STARTUP_CONFIG, "w") as fd:
+                fd.write(config.dump())
         else:
             self.shell.log.warning("Aborted, configuration left untouched.")
 
+    def ui_command_configure(self):
+        '''
+        Enters the config mode.
+
+        This mode allows editing a candidate configuration without
+        impacting the running system. This candidate configuration can
+        then either be commited or discarded at will. If commited, it
+        will be applied to the running system and saved as the new
+        startup configuration.
+
+        Other features include loading a configuration from file, undo
+        support, rollback support, configuration backups and more.
+
+        This mode is a functionnal but early preview version of the next-
+        generation targetcli environment.
+        '''
+        self.assert_root()
+        self.shell.log.warning("Entering configure mode")
+        self.shell.log.warning("This mode is a functionnal but early "
+                               "preview version of the next-generation "
+                               "targetcli")
+        #tmp_fd = tempfile.NamedTemporaryFile()
+        #tmp_history = tmp_fd.name
+        #tmp_fd.close()
+        #readline.write_history_file(tmp_history)
+        #readline.clear_history()
+        #CliConfig(interactive=True).cmdloop()
+        #readline.clear_history()
+        #readline.read_history_file(tmp_history)
+        system("targetcli-ng configure")
+        self.refresh()
+
     def ui_command_version(self):
         '''
         Displays the targetcli and support libraries versions.
diff --git a/targetcli/ui_target.py b/targetcli/ui_target.py
index 8f27278..cd4efed 100644
--- a/targetcli/ui_target.py
+++ b/targetcli/ui_target.py
@@ -2,7 +2,7 @@
 Implements the targetcli target related UI.
 
 This file is part of targetcli.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -255,7 +255,7 @@ class UIMultiTPGTarget(UIRTSLibNode):
         '''
         Creates a new Target Portal Group within the target. The I{tag} must be
         a strictly positive integer value. If omitted, the next available
-        Target Portal Group Tag (TPGT) will be used.
+        Target Portal Group Tag (TPG) will be used.
 
         SEE ALSO
         ========
@@ -280,30 +280,32 @@ class UIMultiTPGTarget(UIRTSLibNode):
                 self.shell.log.error("The TPG Tag must be an integer value.")
                 return
             else:
-                if tag < 1:
-                    self.shell.log.error("The TPG Tag must be >0.")
+                if tag < 0:
+                    self.shell.log.error("The TPG Tag must be 0 or more.")
                     return
 
         tpg = TPG(self.rtsnode, tag, mode='create')
         if self.shell.prefs['auto_enable_tpgt']:
             tpg.enable = True
-        self.shell.log.info("Successfully created TPG %s." % tpg.tag)
+        self.shell.log.info("Created TPG %s." % tpg.tag)
         ui_tpg = UITPG(tpg, self)
         return self.new_node(ui_tpg)
 
     def ui_command_delete(self, tag):
         '''
-        Deletes the Target Portal Group with TPGT I{tag} from the target. The
-        I{tag} must be a positive integer matching an existing TPGT.
+        Deletes the Target Portal Group with TPG I{tag} from the target. The
+        I{tag} must be a positive integer matching an existing TPG.
 
         SEE ALSO
         ========
         B{create}
         '''
         self.assert_root()
-        tpg = TPG(self.rtsnode, tag, mode='lookup')
+        if tag.startswith("tpg"):
+            tag = tag[3:]
+        tpg = TPG(self.rtsnode, int(tag), mode='lookup')
         tpg.delete()
-        self.shell.log.info("Deleted TPGT %s." % tag)
+        self.shell.log.info("Deleted TPG %s." % tag)
         self.refresh()
 
     def ui_complete_delete(self, parameters, text, current_param):
@@ -335,7 +337,7 @@ class UITPG(UIRTSLibNode):
     A generic TPG UI.
     '''
     def __init__(self, tpg, parent):
-        name = "tpgt%d" % tpg.tag
+        name = "tpg%d" % tpg.tag
         UIRTSLibNode.__init__(self, name, tpg, parent)
         self.cfs_cwd = tpg.path
         self.refresh()
@@ -349,12 +351,12 @@ class UITPG(UIRTSLibNode):
 
     def summary(self):
         if self.rtsnode.has_feature('nexus'):
-            description = "%s" % self.rtsnode.nexus
+            description = ("%s" % self.rtsnode.nexus, True)
         elif self.rtsnode.enable:
-            description = "enabled"
+            description = ("enabled", True)
         else:
-            description = "disabled"
-        return (description, True)
+            description = ("disabled", False)
+        return description
 
     def ui_command_enable(self):
         '''
@@ -366,10 +368,10 @@ class UITPG(UIRTSLibNode):
         '''
         self.assert_root()
         if self.rtsnode.enable:
-            self.shell.log.info("The TPGT is already enabled.")
+            self.shell.log.info("The TPG is already enabled.")
         else:
             self.rtsnode.enable = True
-            self.shell.log.info("The TPGT has been enabled.")
+            self.shell.log.info("The TPG has been enabled.")
 
     def ui_command_disable(self):
         '''
@@ -382,9 +384,9 @@ class UITPG(UIRTSLibNode):
         self.assert_root()
         if self.rtsnode.enable:
             self.rtsnode.enable = False
-            self.shell.log.info("The TPGT has been disabled.")
+            self.shell.log.info("The TPG has been disabled.")
         else:
-            self.shell.log.info("The TPGT is already disabled.")
+            self.shell.log.info("The TPG is already disabled.")
 
 
 class UITarget(UITPG):
@@ -456,10 +458,10 @@ class UINodeACLs(UINode):
         try:
             node_acl = NodeACL(self.tpg, wwn, mode="create")
         except RTSLibError, msg:
-            self.shell.log.error(msg)
+            self.shell.log.error(str(msg))
             return
         else:
-            self.shell.log.info("Successfully created Node ACL for %s"
+            self.shell.log.info("Created Node ACL for %s"
                                 % node_acl.node_wwn)
             ui_node_acl = UINodeACL(node_acl, self)
 
@@ -482,7 +484,7 @@ class UINodeACLs(UINode):
         self.assert_root()
         node_acl = NodeACL(self.tpg, wwn, mode='lookup')
         node_acl.delete()
-        self.shell.log.info("Successfully deleted Node ACL %s." % wwn)
+        self.shell.log.info("Deleted Node ACL %s." % wwn)
         self.refresh()
 
     def ui_complete_delete(self, parameters, text, current_param):
@@ -579,6 +581,10 @@ class UINodeACL(UIRTSLibNode):
             self.shell.log.error("Incorrect LUN value.")
             return
 
+        if tpg_lun in (ml.tpg_lun.lun for ml in self.rtsnode.mapped_luns):
+            self.shell.log.warning(
+                "Warning: TPG LUN %d already mapped to this NodeACL" % tpg_lun)
+
         mlun = MappedLUN(self.rtsnode, mapped_lun, tpg_lun, write_protect)
         ui_mlun = UIMappedLUN(mlun, self)
         self.shell.log.info("Created Mapped LUN %s." % mlun.mapped_lun)
@@ -731,7 +737,7 @@ class UILUNs(UINode):
             return
 
         lun_object = LUN(self.tpg, lun, storage_object)
-        self.shell.log.info("Successfully created LUN %s." % lun_object.lun)
+        self.shell.log.info("Created LUN %s." % lun_object.lun)
         ui_lun = UILUN(lun_object, self)
 
         if add_mapped_luns:
@@ -795,11 +801,15 @@ class UILUNs(UINode):
         B{create}
         '''
         self.assert_root()
-        if lun.startswith('lun'):
+        if lun.lower().startswith("lun"):
             lun = lun[3:]
-        lun_object = LUN(self.tpg, lun)
+        try:
+            lun = int(lun)
+            lun_object = LUN(self.tpg, lun)
+        except:
+            raise RTSLibError("Invalid LUN")
         lun_object.delete()
-        self.shell.log.info("Successfully deleted LUN %s." % lun)
+        self.shell.log.info("Deleted LUN %s." % lun)
         # Refresh the TPG as we need to also refresh acls MappedLUNs
         self.parent.refresh()
 
@@ -898,6 +908,12 @@ class UIPortals(UINode):
         B{delete}
         '''
         self.assert_root()
+        try:
+            listen_all = int(ip_address.replace(".", "")) == 0
+        except:
+            listen_all = False
+        if listen_all:
+            ip_address = "0.0.0.0"
         if ip_port is None:
             # FIXME: Add a specfile parameter to determine that
             ip_port = 3260
@@ -912,7 +928,7 @@ class UIPortals(UINode):
                     self.shell.log.error("Cannot find a usable IP address to "
                                          + "create the Network Portal.")
                     return
-        elif ip_address not in utils.list_eth_ips():
+        elif ip_address not in utils.list_eth_ips() and not listen_all:
             self.shell.log.error("IP address does not exist: %s" % ip_address)
             return
 
@@ -922,9 +938,8 @@ class UIPortals(UINode):
             self.shell.log.error("The ip_port must be an integer value.")
             return
 
-        portal = NetworkPortal(self.tpg, ip_address,
-                               ip_port, mode='create')
-        self.shell.log.info("Successfully created network portal %s:%d."
+        portal = NetworkPortal(self.tpg, ip_address, ip_port, mode='create')
+        self.shell.log.info("Created network portal %s:%d."
                             % (ip_address, ip_port))
         ui_portal = UIPortal(portal, self)
         return self.new_node(ui_portal)
